import { select } from 'd3';

export const viz = (container, options) => {
  const [state, setState] = options;
  const { x, y, color } = state;

  const svg = select(container)
    .selectAll('svg')
    .data([null])
    .join('svg')
    .attr('width', window.innerWidth)
    .attr('height', window.innerHeight);

  svg.on('mousemove', (event) => {
    setState((prev) => ({
      ...prev,
      x: event.x,
      y: event.y,
    }));
  });

  svg.on('click', (event) => {
    const r = Math.random() * 255;
    const g = Math.random() * 255;
    const b = Math.random() * 255;
    
    setState((prev) => ({
      ...prev,
      color: `rgb(${r}, ${g}, ${b})`,
    }));
  });

  svg
    .selectAll('circle')
    .data([null])
    .join('circle')
    .attr('cx', x)
    .attr('cy', y)
    .attr('r', 30)
    .style('fill', color);
};
